<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" v-show="searchOpen" :label-width="70" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托商:">
                <Input v-model="formObj.client" @on-enter="_formSearch" placeholder="请输入委托编号" clearable></Input>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" placeholder="请输入委托单位" clearable></Input>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                      class="contHide">
            </btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable
              ref="pageTable"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
                sortable
              >
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id,scope.row.type)">{{scope.row[item.key]}}</a>
                  </div>
                  <span v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.type">{{scope.row[item.key] === 0 ? '企业':scope.row[item.key] ===
                    1?'政府':scope.row[item.key] === 2?'食品类抽样单': ''}}
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <!--组件加载-->
    <!--选择领样人-->
    <keep-alive>
      <!-- eslint-disable-next-line vue/require-component-is -->
      <component ref="refModal" :is="currentComponent" @on-result-change="_componentResult"></component>
    </keep-alive>
<!--    <SampleManage ref="sampleManageModal" @on-result-change="_page"></SampleManage>-->
<!--    <Operation ref="operation"></Operation>-->
<!--    <FileManage ref="FileManage"></FileManage>-->
  </div>
</template>
<script>
import { soilEntrust } from '../../../api'
import Operation from '../../../components/operation/Operation'
import SampleManage from './entrust-sample-manage/SampleManageHis'
export default {
  // eslint-disable-next-line vue/no-unused-components
  components: { SampleManage, Operation },
  data() {
    return {
      formObj: {
        client: undefined,
        entrustCode: undefined
      },
      typeList: [{ name: '企业', value: 0 }, { name: '政府', value: 1 }],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: '',
          name: '管理样品'
        },
        { type: 'md-cloud', id: '', name: '附件' },
        {
          type: 'ios-clock',
          id: '',
          name: '操作日志'
        },
        {
          type: 'md-trash',
          id: '',
          name: '删除'
        }
      ],
      getPage: {},
      pageColumns: [
        { title: '委托商', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托日期', key: 'entrustDate', width: 120, date: true },
        { title: '钻孔位置', key: 'boreholeLocation', width: 120 },
        { title: '水深（米）', key: 'waterDepth', width: 120 },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        { title: '平均容重', key: 'projectNo', width: 120 },
        { title: '报告编号', key: 'reportCode', width: 120 },
        { title: '制表日期', key: 'tabulateDate', width: 120, date: true },
        { title: '制表人', key: 'tabulater', width: 120 },
        { title: '批准日期', key: 'approveDate', width: 120, date: true },
        { title: '批准人', key: 'approver', width: 120 },
        { title: '检验类别', key: 'testType', width: 120 }
      ],
      searchOpen: false,
      btn: [
        {
          type: 'primary',
          id: 'ZBC',
          name: '一键接收'
        }
      ],
      selectIds: [],
      currentComponent: '',
      acceptSelectUserValue: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('tabSearch')
      } else {
        return this.$tableHeight('tabNoSearch')
      }
    }
  },
  mounted() {
    // 样品接收是否选择人员
    // this.acceptSelectUserValue = localStorage.getItem('acceptSelectUserValue')
  },
  methods: {
    // 一键接收并发放

    // 组件返回值
    _componentResult(data, msg) {
      switch (this.currentComponent) {
        default:
          this._page()
      }
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(() => {
        switch (msg) {
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    // 扫码接收并发放
    // 一键接收并发放
    // 一键发放
    // 一键接收
    // 信息维护
    _iconClick(res, data, currentComponent) {
      this.currentComponent = currentComponent
      console.log(res)
      this.$nextTick(() => {
        switch (res) {
          case '管理样品':
            this._editModal(data.id, data.type, data.entrustCode)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '附件':
            this._upload(data.id)
            break
          case '操作日志':
            this._operationRecord(data.id)
            break
        }
      })
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    _delete: async function(ids) {
      const result = await soilEntrust.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    },
    _editModal(id, type, name) {
      this.currentComponent = 'SampleManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(id, type, name)
      })
      // this.$refs.sampleManageModal._open(id, type, name)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this.getPage = this.$store.state.FoodContract.page
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await soilEntrust.pageSampleReceiveHis(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _search() {
      this._page()
    },
    _operationRecord(id) {
      // 操作日志
      this.currentComponent = 'Operation'
      this.$nextTick(() => {
        this.$refs.refModal._open(id)
      })
      // this.$refs.operation._open(id)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodContract.success) {
        this._page()
        this.$Message.success(msg)
        this.selectIds = []
      }
    },
    _upload(id) {
      // 上传文件
      this.currentComponent = 'FileManage'
      this.$nextTick(() => {
        this.$refs.refModal._open(id, 'entrustId')
      })
      // this.$refs.FileManage._open(id, 'entrustId')
    }
  }
}
</script>
